#include "histogram.h"
static vector<size_t> make_histogram(vector<double>& numbers, size_t bin_count)
{
    double min_number, max_number;
    find_minmax(numbers, min_number, max_number);
    vector<size_t> bins(bin_count);
    for (int i = 0; i < bin_count; i++)
    {
        bins[i] = 0;
    }
    double bin_size = (max_number - min_number) / bin_count;
    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min_number + j * bin_size;
            auto hi = min_number + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}

void find_max_capacity(vector<size_t>& bins, size_t& max_bin_capacity)
{
    max_bin_capacity = bins[0];
    for (size_t x : bins)
    {
        if (x > max_bin_capacity)
        {
            max_bin_capacity = x;
        }
    }
}
